<template>
  <div id="app" :class="{ darkMode: this.darkMode }">
    <component :is="layout">
      <transition name="fade" mode="out-in">
        <router-view />
      </transition>
    </component>
    <vue-progress-bar></vue-progress-bar>
    <v-dialog />
    <modals-container />
    <toasters name="main" />
  </div>
</template>

<script>
import { mapState, mapActions, mapGetters, mapMutations } from "vuex";
export default {
  computed: {
    layout() {
      return (this.$route.meta.layout || "main") + "-layout";
    },
    ...mapState(["darkMode"]),
    ...mapState('userModule', ['user']),
    ...mapGetters("userModule", ["loggedIn"])
  },
  created() {
    if (this.loggedIn) {
      this.getUser();
    }

    if (localStorage.getItem("dark") === "true") {
      this.setDarkMode(true);
    }

    this.getProjects();
    this.getAssignedIssues();
  },
  methods: {
    ...mapActions("userModule", ["getUser"]),
    ...mapActions("projectModule", ['getProjects']),
    ...mapActions("issueModule", ['getAssignedIssues']),
    ...mapMutations(["setDarkMode"])
  }
};
</script>

<style lang="scss">
@import url("https://fonts.googleapis.com/css?family=Open+Sans:400,600,700&display=swap");
@import url("https://fonts.googleapis.com/css?family=Raleway:300,400,500,600,700&display=swap");
@import url("https://fonts.googleapis.com/css?family=Roboto:300,400,500,700&display=swap");
@import "./assets/scss/input.scss";
@import "./assets/scss/button.scss";
* {
  margin: 0;
  padding: 0;
  box-sizing: border-box;
  font-family: "Open Sans", sans-serif;
  transition: background-color 0.1s ease-out, border-color 0.1s ease-out,
    color 0.1s ease-out;
}
body {
}

.page-content {
  height: 100vh;
  overflow: auto;
}
.page-title {
  font-size: 30px;
  font-weight: 600;
  color: #454545;
  margin-bottom: 10px;
  margin-top: 10px;
  display: flex;
  align-items: center;
  i {
    margin-right: 10px;
    font-size: 25px;
  }
  .breadcrumbs {
    flex: 1;
    display: flex;
    justify-content: flex-end;
    font-size: 16px;
    color: #747474;
  }
}

.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.15s;
}
.fade-enter, .fade-leave-to /* .fade-leave-active below version 2.1.8 */ {
  opacity: 0;
}

.v--modal-box {
  height: auto !important;
  border-radius: 8px !important;
  overflow: hidden;
  .title {
    font-weight: 600;
    font-size: 18px;
  }
  .subtitle {
    font-weight: 600;
    font-size: 14px;
  }
  .vue-dialog-buttons {
    .vue-dialog-button {
      font-weight: 600;
    }
  }
}
#app {
  min-height: 100vh;
  transition: background-color 0.1s ease-out;
  background-color: #f6f6f6;
  &.darkMode {
    background-color: #2f3641;
    .page-title {
      color: #8b9aa5;
    }
    .v--modal-box {
      background-color: #38414b;
      border: 1px solid #212730;
      .title {
        color: #a7b7c9;
      }
      .subtitle {
        color: #8692a4;
      }
      .dialog-content {
        color: #afc7dc;
      }
      .vue-dialog-buttons {
        border-color: #252f39;
        .vue-dialog-button {
          border-color: #252f39;
          font-weight: 600;
          color: #8197ac;
        }
      }
    }
  }
}
</style>
